###
* omg-configurator
*
* Copyright (c) 2015 Ferrari electronic AG
###

'use strict'
fs = require 'fs'
# luaparse = require 'luaparse'
exec = require "child_process"
	.exec
child_process = require 'child_process'
sh = require("shelljs")

debug = require("debug")("omg-configurator")

Producer = require "class_node_producer"

originalConfigPath = "/data/config.lua"
convertedConfigPath = "/data/config.utf.lua"

getConfigFileEncoding = (cb) ->
	exec "file #{originalConfigPath}", (error, stdout, stderr) ->
		stdout = stdout.toString()
		stdout = stdout.replace /\/data\/config\.lua\:|text|\ |\n/g, ""
		debug "Config file encoding is #{stdout}"
		cb stdout

convertFile = (needsConversion, cb) ->
	unless needsConversion
		sh.cp "-f", originalConfigPath, convertedConfigPath
		cb()
		return

	exec "iconv -f ISO_8859-1 -t UTF-8 #{originalConfigPath} -o #{convertedConfigPath}", (error, stdout, stderr) ->
		debug "converted config.lua: #{stdout}"
		cb()

configLuaAsJson = (cb)->
	confJson = ""
	confGetProc = child_process.spawn "omgconfiginfo", ["--json"]
	confGetProc.stdout.on "data", (data) ->
		confJson = "#{confJson}#{data}"
	confGetProc.on "close", ->
		cb(confJson)

extracted_struct_DChannel = (data) ->
	return data.config.struct_Box.struct_DChannel

class Configurator extends Producer
	constructor: ->
		super "configurator"

		fs.watch "/data/", (event, file) =>
			if file is "config.lua"
				@get "config.lua", (err, data) =>
					@sendData data

		@get = (filename, callback) =>

			debug "request for: #{filename}"
			getConfigFileEncoding (encoding) =>

				if encoding is "ISO-8859"
					needsConversion = true
					debug "Encoding of config.lua is #{encoding}. Needs conversion"

				convertFile needsConversion,  =>

					switch filename
						when "config.lua"
							configLuaAsJson (data)->
								data = JSON.parse(data)
								callback null, {config: data}
						when "config.lua struct_DChannel"
							configLuaAsJson (data)->
								try
									data = JSON.parse(data)
									dataToReturn = data.struct_Box.struct_DChannel
									debug "successfully read data of #{filename}"
									callback null, dataToReturn
								catch e
									debug "Failed to get #{filename}: #{e}"
									callback e

						else
							callback "I don't know that config file!" if callback
							return

		# @set = (filename, configuration) ->
		# 	switch filename
		# 		when "config.lua" then filepath = "#{originalConfigPath}"
		# 		when "config.test" then filepath = "/data/config.test"
		# 		else
		# 			outputCallback "I don't know that config file!"
		# 			return

		# 	exec "#{__dirname}/lua/writeConfig.lua #{filepath} '#{configuration}'", (error, stdout, stderr) ->
		# 		console.log error if error
		# 		console.log stderr if stderr
		# 		#returning the written configuration.
		# 		#Parsing it before hand because it does get send stringified later
		# 		outputCallback null, JSON.parse(configuration)

module.exports = new Configurator()
