// Generated by CoffeeScript 1.9.0

/*
* omg-configurator
*
* Copyright (c) 2015 Ferrari electronic AG
 */
'use strict';
var Configurator, Producer, child_process, configLuaAsJson, convertFile, convertedConfigPath, debug, exec, extracted_struct_DChannel, fs, getConfigFileEncoding, originalConfigPath, sh,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  __hasProp = {}.hasOwnProperty;

fs = require('fs');

exec = require("child_process").exec;

child_process = require('child_process');

sh = require("shelljs");

debug = require("debug")("omg-configurator");

Producer = require("class_node_producer");

originalConfigPath = "/data/config.lua";

convertedConfigPath = "/data/config.utf.lua";

getConfigFileEncoding = function(cb) {
  return exec("file " + originalConfigPath, function(error, stdout, stderr) {
    stdout = stdout.toString();
    stdout = stdout.replace(/\/data\/config\.lua\:|text|\ |\n/g, "");
    debug("Config file encoding is " + stdout);
    return cb(stdout);
  });
};

convertFile = function(needsConversion, cb) {
  if (!needsConversion) {
    sh.cp("-f", originalConfigPath, convertedConfigPath);
    cb();
    return;
  }
  return exec("iconv -f ISO_8859-1 -t UTF-8 " + originalConfigPath + " -o " + convertedConfigPath, function(error, stdout, stderr) {
    debug("converted config.lua: " + stdout);
    return cb();
  });
};

configLuaAsJson = function(cb) {
  var confGetProc, confJson;
  confJson = "";
  confGetProc = child_process.spawn("omgconfiginfo", ["--json"]);
  confGetProc.stdout.on("data", function(data) {
    return confJson = "" + confJson + data;
  });
  return confGetProc.on("close", function() {
    return cb(confJson);
  });
};

extracted_struct_DChannel = function(data) {
  return data.config.struct_Box.struct_DChannel;
};

Configurator = (function(_super) {
  __extends(Configurator, _super);

  function Configurator() {
    Configurator.__super__.constructor.call(this, "configurator");
    fs.watch("/data/", (function(_this) {
      return function(event, file) {
        if (file === "config.lua") {
          return _this.get("config.lua", function(err, data) {
            return _this.sendData(data);
          });
        }
      };
    })(this));
    this.get = (function(_this) {
      return function(filename, callback) {
        debug("request for: " + filename);
        return getConfigFileEncoding(function(encoding) {
          var needsConversion;
          if (encoding === "ISO-8859") {
            needsConversion = true;
            debug("Encoding of config.lua is " + encoding + ". Needs conversion");
          }
          return convertFile(needsConversion, function() {
            switch (filename) {
              case "config.lua":
                return configLuaAsJson(function(data) {
                  data = JSON.parse(data);
                  return callback(null, {
                    config: data
                  });
                });
              case "config.lua struct_DChannel":
                return configLuaAsJson(function(data) {
                  var dataToReturn, e;
                  try {
                    data = JSON.parse(data);
                    dataToReturn = data.struct_Box.struct_DChannel;
                    debug("successfully read data of " + filename);
                    return callback(null, dataToReturn);
                  } catch (_error) {
                    e = _error;
                    debug("Failed to get " + filename + ": " + e);
                    return callback(e);
                  }
                });
              default:
                if (callback) {
                  callback("I don't know that config file!");
                }
            }
          });
        });
      };
    })(this);
  }

  return Configurator;

})(Producer);

module.exports = new Configurator();
