/* exported should */
/* exported co */
/* jshint expr: true */
'use strict';

var omg_configurator = require('../lib/omg-configurator.js');


describe('omg_configurator', function() {
    var config;

    it("should return extracted Struct_DChannel", function(done) {
        var startCallback = function(err) {
            if (err) {
                throw (err);
            }
        };

        var outputCallback = function(err, data) {
            if (err) {
                console.log(err);
                return;
            }
            data.should.be.Array;
            data.should.matchEach(function(it) {
                it.should.have.properties("string_BChannelMap");
            });
            done();
        };
        omg_configurator.get('config.lua struct_Dchannel', startCallback, outputCallback);
    });

    it('should get the config.lua as json', function(done) {

        // var blub = {huhu: "blub"};
        var startCallback = function(err) {
            if (err) {
                throw (err);
            }
        };

        var outputCallback = function(err, data) {
            if (err) {
                console.log(err);
            }
            config = data;
            done();
        };
        omg_configurator.get('config.lua', startCallback, outputCallback);
    });

    it('should set the config.lua from json', function(done) {

        // var blub = {huhu: "blub"};
        var startCallback = function(err) {
            if (err) {
                throw (err);
            }
        };

        var outputCallback = function(err, data) {
            if (err) {
                throw (err);
            }
            data = data.config;
            data.struct_Box.should.have.properties("string_SipBindPort");
            done();
        };

        // var configurationObject = JSON.parse(config);
        var configurationObject = config;

        configurationObject.config.struct_Box.string_SipBindPort = "9998";
        var fileToWrite = "config.test";

        omg_configurator.set(fileToWrite, JSON.stringify(configurationObject), startCallback, outputCallback);
    });

    it('should get the config.lua as json', function(done) {

        // var blub = {huhu: "blub"};
        var startCallback = function(err) {
            if (err) {
                throw (err);
            }
        };

        var outputCallback = function(err, data) {
            if (err) {
                console.log(err);
            }
            data = data.config;
            data.struct_Box.should.have.properties("string_SipBindPort");
            data.struct_Box.string_SipBindPort.should.be.exactly("9998");
            done();
        };
        omg_configurator.get('config.test', startCallback, outputCallback);
    });
});