/* exported should */
/* exported co */
/* jshint expr: true */
'use strict';

global.appConfig = {};
global.appConfig.sudo = true;

var omg_hostinspection = require('../lib/omg-hostinspection.js');


describe('omg_hostinspection', function() {
    this.timeout(15000);
    var pingCounter = 0;
    it('should ping localhost', function(done) {
        var startCallback = function(err, data) {
            console.log(data);
            if (err) {
                throw err;
            }
        };
        var outputCallback = function(err, data) {
            console.log(data);
            if(err){
                err.should.be.exactly("regular stop");
            }
            data.should.be.string;

            pingCounter++;
            if (pingCounter === 4) {
                done();
            }
        };

        var commandObject = {
            command: "ping"
        };


        omg_hostinspection.start(commandObject, startCallback, outputCallback);
    });

    var traceCounter = 0;
    it('should tracepath 10.1.1.13', function(done) {
        var startCallback = function(err, data) {
            console.log(data);
            if (err) {
                throw err;
            }
        };
        var outputCallback = function(err, data) {
            console.log(data);
            if(err){
                err.should.be.exactly("regular stop");
            }
            data.should.be.string;
            traceCounter++;
            if (traceCounter === 2) {
                done();
            }
        };

        var commandObject = {
            command: "tracepath",
            host: "10.1.1.13"
        };


        omg_hostinspection.start(commandObject, startCallback, outputCallback);
    });

    var lookupCounter = 0;
    it('should lookup 10.1.1.13', function(done) {
        var startCallback = function(err, data) {
            console.log(data);
            if (err) {
                throw err;
            }
        };
        var outputCallback = function(err, data) {
            console.log(data);
            if(err){
                err.should.be.exactly("regular stop");
            }
            data.should.be.string;
            lookupCounter++;
            if (lookupCounter === 1) {
                done();
            }
        };

        var commandObject = {
            command: "dnsLookup",
            host: "10.1.1.13"
        };


        omg_hostinspection.start(commandObject, startCallback, outputCallback);
    });

    var portScanCounter = 0;
    it('should do a port scan on 10.1.1.13', function(done) {
        var startCallback = function(err, data) {
            console.log(data);
            if (err) {
                throw err;
            }
        };
        var outputCallback = function(err, data) {
            console.log(data);
            if(err){
                err.should.be.exactly("regular stop");
            }
            data.should.be.string;
            portScanCounter++;
            if (portScanCounter === 12) {
                done();
            }
        };

        var commandObject = {
            command: "portScan",
            host: "10.1.1.13",
            port: "5060",
            proto: "tcp"
        };


        omg_hostinspection.start(commandObject, startCallback, outputCallback);
    });
});