###
* omg-memoryusage
*
* Copyright (c) 2015 Ferrari electronic AG
###

'use strict'

os = require "os"

debug = require("debug")("omg-memoryusage")

Producer = require "class_node_producer"

class Memoryusage extends Producer
  isRunning = false
  constructor: ->
    super "memoryusage", 10 * 1000

    intervalTimeToGetNewData = 60 * 1000

    getNewData = false
    run = =>
      memory =
        total: (os.totalmem() / 1048576).toFixed(0)
        free: (os.freemem() / 1048576).toFixed(0)
      debug "sending memory usage. Free: #{memory.free}"
      @sendData memory

    #run once on load
    run()

    @start = =>
      @debug "starting"
      #run directly
      run()
      clearInterval getNewData if getNewData
      getNewData = setInterval run, intervalTimeToGetNewData #10 * 1000

    @stop = =>
      clearInterval getNewData if getNewData
      isRunning = false

  subscribe: =>
    unless isRunning
      isRunning = true
      @start()
    super

module.exports = new Memoryusage()